<?php

namespace Drupal\broadstreet_ads\Plugin\Block;

use Drupal\Core\Block\BlockBase;

/**
 * Provides an example ad block.
 *
 * @Block(
 *   id = "broadstreet_ads",
 *   admin_label = @Translation("Example ad"),
 *   deriver = "Drupal\broadstreet_ads\Plugin\Derivative\AdBlock"
 * )
 */
class AdBlock extends BlockBase {

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration() {
    return [
      'label_display' => FALSE,
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function build() {
    // @todo Rewrite this using type=html_tag.
    return [
      '#type' => 'markup',
      '#markup' => '<broadstreet-zone zone-id="' . $this->extractZoneId() . '"></broadstreet-zone>',
      '#allowed_tags' => ['broadstreet-zone'],
    ];
  }

  /**
   * Extract the ad zone ID from the plugin ID.
   *
   * The plugin ID will be in the format "broadstreet_ads:ZONEID", so simply
   * remove the first portion of the string to be left with the zone ID.
   *
   * @return int
   *   The ad zone ID represented by this block.
   */
  protected function extractZoneId() {
    return intval(str_replace('broadstreet_ads:', '', $this->pluginId));
  }

}
